/*
 * This file is part of
 *
 * PNET6: a Portable Network Library
 *
 * PNET6 is Copyright (c) 2002, Peter Bozarov
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Peter Bozarov.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * $Id: pkt-ni.c,v 1.5 2002/09/18 06:03:47 kingofgib Exp $
 */


/*----------------------------------------------------------------------*
 * filename:		pkt-ni.c
 * created on:		Sat Jul  6 11:10:18 CEST 2002
 * created by:		peter
 * project: 		PNET6
 *----------------------------------------------------------------------*/

# include "../local.h"
# include "../pkt.h"

# ifndef PNET_HAVE_PACKET_ACCESS

/*----------------------------------------------------------------------*/
/* Dummys for all systems.						*/
/*----------------------------------------------------------------------*/
const char * pkt_get_dl_name(struct pnet_pktacc *pa) 	{ return ""; }
int pkt_get_dl_type(struct pnet_pktacc * pa)		{ return -1; }
int pkt_set_promiscuous(struct pnet_pktacc *pa,int i)	{ return -1; }
int pkt_set_read_timeout(PNetPktAccess * pa,int msec)	{ return -1; }
int pkt_set_filter(PNetPktAccess *pa,PNetPktFilter * pf){ return -1; }
int pkt_next_pkt(PNetPktAccess *pa, PNetPacket *pkt)	{ return  0; }
int pkt_pass_filter(PNetPktAccess*pa,PNetPacket*pkt)	{ return  0; }
void pkt_close_dev( PNetPktAccess * pa ) 	{ return ; }
int pkt_set_mode( PNetPktAccess * pa, int raw ) { return -1; }

int
pkt_get_stats( PNetPktAccess * pa, pnet_uint * caught, pnet_uint * dropped )
{
    return 0;
}
int
pkt_output( PNetPktAccess *pa, pnet_byte * buf, pnet_uint blen )
{
    return 0;
}

struct pnet_pktacc*
pkt_open_dev( const char *ifname, int tries , int dummy )
{
    perr(E_FATAL,"Link layer packet access not available on this OS.\n");
    perr(E_FATAL,"Go to http://pnet6.sourceforge.net for more info.\n");
    return NULL;
    ifname = ifname; tries = tries; dummy= dummy;
}

# endif
